| The Gaudi Framework v32r1 (f65d50dc)

Public Member Functions | Private Member Functions | Private Attributes | List of all members
InertMessageSvc Class Reference

Thread safe extension to the standard MessageSvc. More...

`#include <MessageSvc/InertMessageSvc.h>`

Inheritance diagram for InertMessageSvc:
[legend]
Collaboration diagram for InertMessageSvc:
[legend]

## Public Member Functions
StatusCode | initialize () override
| Initialization of the service. More...
StatusCode | finalize () override
| Finalization of the service. More...
void | reportMessage (const Message &msg) override
| Implementation of IMessageSvc::reportMessage() More...
void | reportMessage (const Message &msg, int outputLevel) override
| Implementation of IMessageSvc::reportMessage() More...
void | reportMessage (const StatusCode &code, const std::string &source="") override
| Implementation of IMessageSvc::reportMessage() More...
| MessageSvc (const std::string &name, ISvcLocator *svcloc)
| Standard constructor. More...
void | reportMessage (const Message &message) override
void | reportMessage (const Message &msg, int outputLevel) override
void | reportMessage (const StatusCode &code, const std::string &source="") override
void | reportMessage (const char *source, int type, const char *message) override
void | reportMessage (const std::string &source, int type, const std::string &message) override
Public Member Functions inherited from MessageSvc
| MessageSvc (const std::string &name, ISvcLocator *svcloc)
StatusCode | reinitialize () override
| Reinitialize Service. More...
StatusCode | initialize () override
| Initialize Service. More...
StatusCode | finalize () override
| Finalize Service. More...
void | reportMessage (const Message &message) override
void | reportMessage (const Message &msg, int outputLevel) override
void | reportMessage (const StatusCode &code, const std::string &source="") override
void | reportMessage (const char *source, int type, const char *message) override
void | reportMessage (const std::string &source, int type, const std::string &message) override
void | insertMessage (const StatusCode &code, const Message &message) override
void | eraseMessage () override
void | eraseMessage (const StatusCode &code) override
void | eraseMessage (const StatusCode &code, const Message &message) override
void | insertStream (int message_type, const std::string &name, std::ostream *stream) override
void | eraseStream () override
void | eraseStream (int message_type) override
void | eraseStream (int message_type, std::ostream *stream) override
void | eraseStream (std::ostream *stream) override
std::ostream * | defaultStream () const override
void | setDefaultStream (std::ostream *stream) override
int | outputLevel () const override
int | outputLevel (const std::string &source) const override
void | setOutputLevel (int new_level) override
void | setOutputLevel (const std::string &source, int new_level) override
bool | useColor () const override
std::string | getLogColor (int logLevel) const override
int | messageCount (MSG::Level logLevel) const override
void | incrInactiveCount (MSG::Level level, const std::string &src) override
Public Member Functions inherited from extends< Service, IMessageSvc, IInactiveMessageCounter >
void * | i_cast (const InterfaceID &tid) const override
| Implementation of IInterface::i_cast. More...
StatusCode | queryInterface (const InterfaceID &ti, void **pp) override
| Implementation of IInterface::queryInterface. More...
std::vector< std::string > | getInterfaceNames () const override
| Implementation of IInterface::getInterfaceNames. More...
Public Member Functions inherited from Service
const std::string & | name () const override
| Retrieve name of the service. More...
StatusCode | configure () override
StatusCode | initialize () override
StatusCode | start () override
StatusCode | stop () override
StatusCode | finalize () override
StatusCode | terminate () override
Gaudi::StateMachine::State | FSMState () const override
Gaudi::StateMachine::State | targetFSMState () const override
StatusCode | reinitialize () override
StatusCode | restart () override
StatusCode | sysInitialize () override
| Initialize Service. More...
StatusCode | sysStart () override
| Initialize Service. More...
StatusCode | sysStop () override
| Initialize Service. More...
StatusCode | sysFinalize () override
| Finalize Service. More...
StatusCode | sysReinitialize () override
| Re-initialize the Service. More...
StatusCode | sysRestart () override
| Re-initialize the Service. More...
| Service (std::string name, ISvcLocator *svcloc)
| Standard Constructor. More...
SmartIF< ISvcLocator > & | serviceLocator () const override
| Retrieve pointer to service locator. More...
StatusCode | setProperties ()
| Method for setting declared properties to the values specified for the job. More...
template<class T >
StatusCode | service (const std::string &name, const T *&psvc, bool createIf=true) const
| Access a service by name, creating it if it doesn't already exist. More...
template<class T >
StatusCode | service (const std::string &name, T *&psvc, bool createIf=true) const
template<typename IFace = IService>
SmartIF< IFace > | service (const std::string &name, bool createIf=true) const
template<class T >
StatusCode | service (const std::string &svcType, const std::string &svcName, T *&psvc) const
| Access a service by name and type, creating it if it doesn't already exist. More...
template<class T >
StatusCode | declareTool (ToolHandle< T > &handle, std::string toolTypeAndName, bool createIf=true)
| Declare used tool. More...
SmartIF< IAuditorSvc > & | auditorSvc () const
| The standard auditor service.May not be invoked before sysInitialize() has been invoked. More...
Public Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| PropertyHolder ()=default
Gaudi::Details::PropertyBase & | declareProperty (Gaudi::Details::PropertyBase &prop)
| Declare a property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, TYPE &value, const std::string &doc="none")
| Helper to wrap a regular data member and use it as a regular property. More...
Gaudi::Details::PropertyBase * | declareProperty (const std::string &name, Gaudi::Property< TYPE, VERIFIER, HANDLERS > &prop, const std::string &doc="none")
| Declare a PropertyBase instance setting name and documentation. More...
Gaudi::Details::PropertyBase * | declareRemoteProperty (const std::string &name, IProperty *rsvc, const std::string &rname="")
| Declare a remote property. More...
StatusCode | setProperty (const Gaudi::Details::PropertyBase &p) override
| set the property form another property More...
StatusCode | setProperty (const std::string &s) override
| set the property from the formatted string More...
StatusCode | setProperty (const std::string &n, const std::string &v) override
| set the property from name and the value More...
StatusCode | setProperty (const std::string &name, const TYPE &value)
| set the property form the value More...
StatusCode | getProperty (Gaudi::Details::PropertyBase *p) const override
| get the property More...
const Gaudi::Details::PropertyBase & | getProperty (const std::string &name) const override
| get the property by name More...
StatusCode | getProperty (const std::string &n, std::string &v) const override
| convert the property to the string More...
const std::vector< Gaudi::Details::PropertyBase * > & | getProperties () const override
| get all properties More...
bool | hasProperty (const std::string &name) const override
| Return true if we have a property with the given name. More...
| PropertyHolder (const PropertyHolder &)=delete
PropertyHolder & | operator= (const PropertyHolder &)=delete
Public Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | msgLevel () const
| get the cached level (originally extracted from the embedded MsgStream) More...
bool | msgLevel (MSG::Level lvl) const
| get the output level from the embedded MsgStream More...
MSG::Level | outputLevel () const
| Backward compatibility function for getting the output level. More...
Public Member Functions inherited from CommonMessagingBase
virtual | ~CommonMessagingBase ()=default
| Virtual destructor. More...
const SmartIF< IMessageSvc > & | msgSvc () const
| The standard message service. More...
MsgStream & | msgStream () const
| Return an uninitialized MsgStream. More...
MsgStream & | msgStream (const MSG::Level level) const
| Predefined configurable message stream for the efficient printouts. More...
MsgStream & | always () const
| shortcut for the method msgStream(MSG::ALWAYS) More...
MsgStream & | fatal () const
| shortcut for the method msgStream(MSG::FATAL) More...
MsgStream & | err () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | error () const
| shortcut for the method msgStream(MSG::ERROR) More...
MsgStream & | warning () const
| shortcut for the method msgStream(MSG::WARNING) More...
MsgStream & | info () const
| shortcut for the method msgStream(MSG::INFO) More...
MsgStream & | debug () const
| shortcut for the method msgStream(MSG::DEBUG) More...
MsgStream & | verbose () const
| shortcut for the method msgStream(MSG::VERBOSE) More...
MsgStream & | msg () const
| shortcut for the method msgStream(MSG::INFO) More...

## Private Member Functions
void | m_activate ()
void | m_deactivate ()

## Private Attributes
bool | m_isActive = false
tbb::concurrent_bounded_queue< std::function< void()> > | m_messageActionsQueue
std::thread | m_thread

## Additional Inherited Members
Public Types inherited from MessageSvc
typedef std::pair< std::string, std::ostream * > | NamedStream
typedef std::multimap< int, NamedStream > | StreamMap
typedef std::multimap< StatusCode, Message > | MessageMap
typedef std::map< std::string, int > | ThresholdMap
Public Types inherited from extends< Service, IMessageSvc, IInactiveMessageCounter >
using | base_class = extends
| Typedef to this class. More...
using | extend_interfaces_base = extend_interfaces< Interfaces... >
| Typedef to the base of this class. More...
Public Types inherited from Service
using | Factory = Gaudi::PluginService::Factory< IService *(const std::string &, ISvcLocator *)>
Public Types inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
using | PropertyHolderImpl = PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
| Typedef used to refer to this class from derived classes, as in. More...
Public Types inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
using | base_class = CommonMessaging
Public Types inherited from extend_interfaces< Interfaces... >
using | ext_iids = typename Gaudi::interface_list_cat< typename Interfaces::ext_iids... >::type
| take union of the ext_iids of all Interfaces... More...
Protected Member Functions inherited from MessageSvc
virtual void | i_reportMessage (const Message &msg, int outputLevel)
| Internal implementation of reportMessage(const Message&,int) without lock. More...
virtual void | i_reportMessage (const StatusCode &code, const std::string &source)
| Internal implementation of reportMessage(const StatusCode&,const std::string&) without lock. More...
Protected Member Functions inherited from Service
| ~Service () override
| Standard Destructor. More...
int | outputLevel () const
| get the `Service's` output level More...
Protected Member Functions inherited from PropertyHolder< CommonMessaging< implements< IService, IProperty, IStateful > > >
Gaudi::Details::PropertyBase * | property (const std::string &name) const
Protected Member Functions inherited from CommonMessaging< implements< IService, IProperty, IStateful > >
MSG::Level | setUpMessaging () const
| Set up local caches. More...
MSG::Level | resetMessaging ()
| Reinitialize internal states. More...
void | updateMsgStreamOutputLevel (int level)
| Update the output level of the cached MsgStream. More...
Protected Attributes inherited from Service
Gaudi::StateMachine::State | m_state = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::StateMachine::State | m_targetState = Gaudi::StateMachine::OFFLINE
| Service state. More...
Gaudi::Property< int > | m_outputLevel {this, "OutputLevel", MSG::NIL, "output level"}
Gaudi::Property< bool > | m_auditInit {this, "AuditServices", false, " unused"}
Gaudi::Property< bool > | m_auditorInitialize {this, "AuditInitialize", false, "trigger auditor on initialize()"}
Gaudi::Property< bool > | m_auditorStart {this, "AuditStart", false, "trigger auditor on start()"}
Gaudi::Property< bool > | m_auditorStop {this, "AuditStop", false, "trigger auditor on stop()"}
Gaudi::Property< bool > | m_auditorFinalize {this, "AuditFinalize", false, "trigger auditor on finalize()"}
Gaudi::Property< bool > | m_auditorReinitialize {this, "AuditReinitialize", false, "trigger auditor on reinitialize()"}
Gaudi::Property< bool > | m_auditorRestart {this, "AuditRestart", false, "trigger auditor on restart()"}
SmartIF< IAuditorSvc > | m_pAuditorSvc
| Auditor Service. More...

## Detailed Description

Thread safe extension to the standard MessageSvc.

The InertMessageSvc runs in a separate thread sleeping until the arrival of a message to print out therefore using a very limited amount of resources. The most important part of its implementation is the presence of a TBB concurrent bounded queue which not only allows to serialise the received messages in order to print them but also to put the thread where the service is located to sleep when the queue is empty.

Author
  Danilo Piparo

Date
  12/02/2013

Definition at line 26 of file InertMessageSvc.h.

## Member Function Documentation

## ◆ finalize()

StatusCode InertMessageSvc::finalize | ( |  | ) |
| override

Finalization of the service.

## ◆ initialize()

StatusCode InertMessageSvc::initialize | ( |  | ) |
| override

Initialization of the service.

Definition at line 14 of file InertMessageSvc.cpp.

14 {
15 StatusCode sc = MessageSvc::initialize(); // must be executed first
16 if ( sc.isFailure() ) return sc; // error printed already by MessageSvc
17
18 info() << "Activating in a separate thread" << endmsg;
19 m_thread = std::thread( &InertMessageSvc::m_activate, this );
20
21 return StatusCode::SUCCESS;
22 }
StatusCode::SUCCESS
constexpr static const auto SUCCESS
Definition: StatusCode.h:85
CommonMessagingBase::info
MsgStream & info() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:104
InertMessageSvc::m_thread
std::thread m_thread
Definition: InertMessageSvc.h:55
MessageSvc::initialize
StatusCode initialize() override
Initialize Service.
Definition: MessageSvc.cpp:106
StatusCode
This class is used for returning status codes from appropriate routines.
Definition: StatusCode.h:50
StatusCode::isFailure
bool isFailure() const
Definition: StatusCode.h:130
InertMessageSvc::m_activate
void m_activate()
Definition: InertMessageSvc.cpp:34
std::thread
STL class.
endmsg
MsgStream & endmsg(MsgStream &s)
MsgStream Modifier: endmsg. Calls the output method of the MsgStream.
Definition: MsgStream.h:192

## ◆ m_activate()

void InertMessageSvc::m_activate | ( |  | ) |
| private

Definition at line 34 of file InertMessageSvc.cpp.

34 {
35 m_isActive = true;
36 std::function<void()> thisMessageAction;
37 while ( m_isActive || !m_messageActionsQueue.empty() ) {
38 m_messageActionsQueue.pop( thisMessageAction );
39 if ( thisMessageAction ) thisMessageAction();
40 }
41 }
std::function
InertMessageSvc::m_messageActionsQueue
tbb::concurrent_bounded_queue< std::function< void()> > m_messageActionsQueue
Definition: InertMessageSvc.h:53
InertMessageSvc::m_isActive
bool m_isActive
Definition: InertMessageSvc.h:51

## ◆ m_deactivate()

void InertMessageSvc::m_deactivate | ( |  | ) |
| private

Definition at line 45 of file InertMessageSvc.cpp.

45 {
46 if ( m_isActive ) {
47 // This would be the last action
48 m_messageActionsQueue.emplace( [this]() { m_isActive = false; } );
49 }
50 }
InertMessageSvc::m_messageActionsQueue
tbb::concurrent_bounded_queue< std::function< void()> > m_messageActionsQueue
Definition: InertMessageSvc.h:53
InertMessageSvc::m_isActive
bool m_isActive
Definition: InertMessageSvc.h:51

## ◆ MessageSvc()

MessageSvc::MessageSvc

Standard constructor.

Definition at line 78 of file MessageSvc.cpp.

78 : base_class( name, svcloc ) {
79
80 m_outputLevel.declareUpdateHandler( [svcloc]( Gaudi::Details::PropertyBase& ) {
81 SmartIF<IAppMgrUI> app = svcloc;
82 if ( app ) app->outputLevelUpdate();
83 } );
84
85 #ifndef NDEBUG
86 // initialize the MsgStream static flag.
87 MsgStream::enableCountInactive( m_inactCount );
88 #endif
89
90 for ( int ic = 0; ic < MSG::NUM_LEVELS; ++ic ) {
91 m_logColors[ic].declareUpdateHandler( &MessageSvc::setupColors, this );
92 m_msgLimit[ic].declareUpdateHandler( &MessageSvc::setupLimits, this );
93 m_thresholdProp[ic].declareUpdateHandler( &MessageSvc::setupThreshold, this );
94 }
95
96 m_logColors[MSG::FATAL].set( {"blue", "red"} );
97 m_logColors[MSG::ERROR].set( {"white", "red"} );
98 m_logColors[MSG::WARNING].set( {"yellow"} );
99
100 std::fill( std::begin( m_msgCount ), std::end( m_msgCount ), 0 );
101 }
Service::m_outputLevel
Gaudi::Property< int > m_outputLevel
Definition: Service.h:176
SmartIF< IAppMgrUI >
std::end
T end(T... args)
extends< Service, IMessageSvc, IInactiveMessageCounter >::base_class
extends base_class
Typedef to this class.
Definition: extends.h:14
MessageSvc::setupColors
void setupColors(Gaudi::Details::PropertyBase &prop)
Definition: MessageSvc.cpp:133
IAppMgrUI::outputLevelUpdate
virtual void outputLevelUpdate()=0
Function to call to update the outputLevel of the components (after a change in MessageSvc).
MSG::FATAL
Definition: IMessageSvc.h:15
MessageSvc::m_inactCount
Gaudi::Property< bool > m_inactCount
Definition: MessageSvc.h:165
Service::name
const std::string & name() const override
Retrieve name of the service.
Definition: Service.cpp:274
MessageSvc::m_logColors
std::array< Gaudi::Property< std::vector< std::string > >, MSG::NUM_LEVELS > m_logColors
Definition: MessageSvc.h:146
Gaudi::Details::PropertyBase
PropertyBase base class allowing PropertyBase* collections to be "homogeneous".
Definition: Property.h:32
std::begin
T begin(T... args)
MSG::NUM_LEVELS
Definition: IMessageSvc.h:15
MSG::ERROR
Definition: IMessageSvc.h:15
MessageSvc::setupLimits
void setupLimits(Gaudi::Details::PropertyBase &prop)
Definition: MessageSvc.cpp:175
MessageSvc::setupThreshold
void setupThreshold(Gaudi::Details::PropertyBase &prop)
Definition: MessageSvc.cpp:195
MessageSvc::m_msgCount
std::array< int, MSG::NUM_LEVELS > m_msgCount
Definition: MessageSvc.h:194
MessageSvc::m_thresholdProp
std::array< Gaudi::Property< std::vector< std::string > >, MSG::NUM_LEVELS > m_thresholdProp
Definition: MessageSvc.h:135
MSG::WARNING
Definition: IMessageSvc.h:15
std::fill
T fill(T... args)
MessageSvc::m_msgLimit
std::array< Gaudi::Property< int >, MSG::NUM_LEVELS > m_msgLimit
Definition: MessageSvc.h:155
MsgStream::enableCountInactive
static GAUDI_API bool enableCountInactive(bool value=true)
Enable/disable the count of inactive messages.
Definition: MsgStream.cpp:31

## ◆ reportMessage() [1/8]

void MessageSvc::reportMessage
| override

Definition at line 427 of file MessageSvc.cpp.

427 {
428 reportMessage( Message{source, type, message} );
429 }
InertMessageSvc::reportMessage
void reportMessage(const Message &msg) override
Implementation of IMessageSvc::reportMessage()
Definition: InertMessageSvc.cpp:67
gaudirun.type
type
Definition: gaudirun.py:142
Message
The Message class.
Definition: Message.h:17

## ◆ reportMessage() [2/8]

void MessageSvc::reportMessage
| override

Definition at line 409 of file MessageSvc.cpp.

409 { reportMessage( msg, outputLevel( msg.getSource() ) ); }
InertMessageSvc::reportMessage
void reportMessage(const Message &msg) override
Implementation of IMessageSvc::reportMessage()
Definition: InertMessageSvc.cpp:67
CommonMessagingBase::msg
MsgStream & msg() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:113
MessageSvc::outputLevel
int outputLevel() const override
Definition: MessageSvc.cpp:566

## ◆ reportMessage() [3/8]

void MessageSvc::reportMessage
| override

Definition at line 351 of file MessageSvc.cpp.

351 {
352 std::unique_lock<std::recursive_mutex> lock( m_reportMutex );
353 i_reportMessage( msg, outputLevel );
354 }
MessageSvc::i_reportMessage
virtual void i_reportMessage(const Message &msg, int outputLevel)
Internal implementation of reportMessage(const Message&,int) without lock.
Definition: MessageSvc.cpp:356
std::lock
T lock(T... args)
MessageSvc::m_reportMutex
std::recursive_mutex m_reportMutex
Mutex to synchronize multiple threads printing.
Definition: MessageSvc.h:209
std::unique_lock
CommonMessagingBase::msg
MsgStream & msg() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:113
MessageSvc::outputLevel
int outputLevel() const override
Definition: MessageSvc.cpp:566

## ◆ reportMessage() [4/8]

void MessageSvc::reportMessage
| override

Definition at line 417 of file MessageSvc.cpp.

417 {
418 reportMessage( Message{source, type, message} );
419 }
InertMessageSvc::reportMessage
void reportMessage(const Message &msg) override
Implementation of IMessageSvc::reportMessage()
Definition: InertMessageSvc.cpp:67
gaudirun.type
type
Definition: gaudirun.py:142
Message
The Message class.
Definition: Message.h:17

## ◆ reportMessage() [5/8]

void MessageSvc::reportMessage
| override

Definition at line 437 of file MessageSvc.cpp.

437 {
438 std::unique_lock<std::recursive_mutex> lock( m_messageMapMutex );
439 i_reportMessage( code, source );
440 }
MessageSvc::i_reportMessage
virtual void i_reportMessage(const Message &msg, int outputLevel)
Internal implementation of reportMessage(const Message&,int) without lock.
Definition: MessageSvc.cpp:356
MessageSvc::m_messageMapMutex
std::recursive_mutex m_messageMapMutex
Mutex to synchronize multiple access to m_messageMap.
Definition: MessageSvc.h:212
std::lock
T lock(T... args)
std::unique_lock

## ◆ reportMessage() [6/8]

void InertMessageSvc::reportMessage | ( | const Message & | msg | ) |
| override

Implementation of IMessageSvc::reportMessage()

Definition at line 67 of file InertMessageSvc.cpp.

67 {
68 // msg has to be copied as the reference may become invalid by the time it's used
69 m_messageActionsQueue.emplace(
70 [this, m = Message( msg )]() { this->i_reportMessage( m, this->outputLevel( m.getSource() ) ); } );
71 }
MessageSvc::i_reportMessage
virtual void i_reportMessage(const Message &msg, int outputLevel)
Internal implementation of reportMessage(const Message&,int) without lock.
Definition: MessageSvc.cpp:356
Gaudi::Units::m
constexpr double m
Definition: SystemOfUnits.h:92
InertMessageSvc::m_messageActionsQueue
tbb::concurrent_bounded_queue< std::function< void()> > m_messageActionsQueue
Definition: InertMessageSvc.h:53
CommonMessagingBase::msg
MsgStream & msg() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:113
Message
The Message class.
Definition: Message.h:17
MessageSvc::outputLevel
int outputLevel() const override
Definition: MessageSvc.cpp:566

## ◆ reportMessage() [7/8]

void InertMessageSvc::reportMessage | ( | const Message & | msg,
|  | int | outputLevel
| ) |  |
| override

Implementation of IMessageSvc::reportMessage()

The message action is created and pushed to the message queue.

The message is captured by value since the one referenced by msg can (and basically always will given the asynchronous nature of the printing) go out of scope before the differed print.

Definition at line 59 of file InertMessageSvc.cpp.

59 {
60 // msg has to be copied as the reference may become invalid by the time it is used
61 m_messageActionsQueue.emplace(
62 [this, m = Message( msg ), outputLevel]() { this->i_reportMessage( m, outputLevel ); } );
63 }
MessageSvc::i_reportMessage
virtual void i_reportMessage(const Message &msg, int outputLevel)
Internal implementation of reportMessage(const Message&,int) without lock.
Definition: MessageSvc.cpp:356
Gaudi::Units::m
constexpr double m
Definition: SystemOfUnits.h:92
InertMessageSvc::m_messageActionsQueue
tbb::concurrent_bounded_queue< std::function< void()> > m_messageActionsQueue
Definition: InertMessageSvc.h:53
CommonMessagingBase::msg
MsgStream & msg() const
shortcut for the method msgStream(MSG::INFO)
Definition: CommonMessaging.h:113
Message
The Message class.
Definition: Message.h:17
MessageSvc::outputLevel
int outputLevel() const override
Definition: MessageSvc.cpp:566

## ◆ reportMessage() [8/8]

void InertMessageSvc::reportMessage | ( | const StatusCode & | code,
|  | const std::string & | source = `""`
| ) |  |
| override

Implementation of IMessageSvc::reportMessage()

Definition at line 75 of file InertMessageSvc.cpp.

75 {
76 // msg has to be copied as the source may become invalid by the time it's used
77 m_messageActionsQueue.emplace( [this, code, s = std::string( source )]() { this->i_reportMessage( code, s ); } );
78 }
MessageSvc::i_reportMessage
virtual void i_reportMessage(const Message &msg, int outputLevel)
Internal implementation of reportMessage(const Message&,int) without lock.
Definition: MessageSvc.cpp:356
std::string
STL class.
InertMessageSvc::m_messageActionsQueue
tbb::concurrent_bounded_queue< std::function< void()> > m_messageActionsQueue
Definition: InertMessageSvc.h:53
gaudirun.s
string s
Definition: gaudirun.py:316

## Member Data Documentation

## ◆ m_isActive

bool InertMessageSvc::m_isActive = false
| private

Definition at line 51 of file InertMessageSvc.h.

## ◆ m_messageActionsQueue

tbb::concurrent_bounded_queue<std::function<void()> > InertMessageSvc::m_messageActionsQueue
| private

Definition at line 53 of file InertMessageSvc.h.

## ◆ m_thread

std::thread InertMessageSvc::m_thread
| private

Definition at line 55 of file InertMessageSvc.h.

The documentation for this class was generated from the following files:

- GaudiCoreSvc/src/MessageSvc/InertMessageSvc.h
- GaudiCoreSvc/src/MessageSvc/InertMessageSvc.cpp